#pragma once

#include <mpma/base/Types.h>
#include <string>
#include <vector>
#include <list>

//Sound samples.  For Vanguard these tend to be in Ogg Vorbis format.
struct IsbSoundSample
{
    std::string Id;
    uint32 Index;
    std::string Isgn;
    std::vector<unsigned char> Data;
};

//No idea sqob what it stands for, but for Vanguard this contains a list of sound sample indexes to be played together that make up what I call a "combination".
struct IcbSqobStat
{
    std::string Title;
    uint32 Index;
    std::string Isgn;
    uint32 TrackCount; //a little redundant, but it's in the data in the file so storing it here for debugging
    std::vector<uint32> TrackIndexes;
};

//No idea what sdri stands for, but for Vanguard this contains a sequence of sqob indexes to be played one after the other to make up a music theme.
struct IcbSdriStat
{
    std::string Title;
    uint32 Index;
    std::string Isgn;
    uint32 TrackCount; //a little redundant, but it's in the data in the file so storing it here for debugging
    std::vector<uint32> SqobIndexes;
};

//No idea what this data is for.
struct IcbEntoStat
{
    std::string Title;
    uint32 Index;
    std::string Isgn;
    uint32 TrackCount; //a little redundant, but it's in the data in the file so storing it here for debugging
};

//Note that ICB and ISB files share the same format.  This class can be used to load both of them.
class FileIsb
{
public:
    bool Load(const std::string &filename);

    std::string Name; //for reference only, set after Load
    std::list<IsbSoundSample> SoundSamples;
    std::list<IcbSqobStat> SqobStats;
    std::list<IcbSdriStat> SdriStats;
    std::list<IcbEntoStat> EntoStats;
};
