//monitors an audio source and renders a simple scene showing what's been completed and the progress on the current source

#pragma once

#include <mpma/base/Timer.h>
#include <mpma/audio/Source.h>
#include <vector>
#include <string>
#include <memory>

class ProgressStream: public AUDIO::Source
{
public:
    inline ProgressStream(const std::string &titleString): title(titleString)
    {
    }

    virtual nuint FillData(void *data, nuint maxSamples);
    virtual nuint GetRemainingSamples() const;
    virtual bool IsStereo() const;
    virtual nuint GetSampleRate() const;
    virtual void Seek(nuint sampleNumber=0);

    void SetNewSource(const std::string &newLabel, std::shared_ptr<AUDIO::Source> passthroughSource=nullptr);

private:
    void UpdateProgress(nuint amount);

    std::shared_ptr<AUDIO::Source> source;
    std::string title;
    std::vector<std::string> completedLabels;
    std::string currentLabel;
    nuint currentProgress=0;
    MPMA::Timer timer;
};
