//blocks and renders a text-based menu of choices, until a choice is made.

#pragma once

#include <mpma/gfxsetup/GFXSetup.h>
#include <mpma/gfx/TextWriter.h>
#include <list>
#include <string>

class TextMenuEntry
{
public:
    std::string Text;
    std::string ParamString;
    void *ParamPtr;
    int ParamInt;
    bool Active=false;

    TextMenuEntry(const std::string &text, const std::string paramString, int paramInt, void *paramPtr);

private:
    int yMin=0;
    int yMax=0;
    int xMin=0;
    int xMax=0;
    GFX::TextWriter textWriter;
    bool clickingSetsAsActive=true;

    void ReRenderText();

    friend class TextMenu;
};

class TextMenu
{
public:
    std::string Title;
    std::list<TextMenuEntry> Choices;
    std::list<TextMenuEntry> AlwaysVisibleChoices;

    TextMenuEntry* GetChoice();

    TextMenu();

private:
    GFX::TextWriter titleWriter;
    int xOffset=0;
};
